#pragma once

class DX10Framework
{
public:
	DX10Framework(void);
	~DX10Framework(void);

	void SetDevice( ID3D10Device* pd3dDevice ) { _device = pd3dDevice; }
	void SetSwapChain( IDXGISwapChain* pSwapChain );

	virtual HRESULT OnCreateDevice( const DXGI_SURFACE_DESC* pBackBufferSurfaceDesc ) { return S_OK; }
	virtual HRESULT OnResizedSwapChain(	const DXGI_SURFACE_DESC* pBackBufferSurfaceDesc) { return S_OK; }
	virtual void OnFrameMove( double fTime, float fElapsedTime ) {}

	virtual void OnFrameRender( double fTime, float fElapsedTime ) {}
	virtual void OnReleasingSwapChain();
	virtual void OnDestroyDevice()	{}

	virtual void OnKeyboard( UINT nChar, bool bKeyDown, bool bAltDown )	{}
	virtual void OnMouse( bool bLeftButtonDown, bool bRightButtonDown, bool bMiddleButtonDown,
		bool bSideButton1Down, bool bSideButton2Down, int nMouseWheelDelta,
		int xPos, int yPos ) {}

protected:
	ID3D10Device* _device;
	IDXGISwapChain* _swapChain;
	ID3D10RenderTargetView* _defaultRenderTargetView;
	ID3D10DepthStencilView* _defaultDepthStencilView;

};
